HDU 3724 Encoded Barcodes (Trie)

题意:给n个字符串,给m个询问,每个询问给k个条形码。每个条形码由8个小码组成,每个小码有相应的宽度,已知一个条形码的宽度只有2种,宽的表示1,窄的表示0。并且宽的宽度是窄的宽度的2倍。由于扫描的时候有误差,每个小码的宽度为一个浮点型数据,保证每个数据的误差在5%内。所以一个条形码可以对应一个ASCC码,表示一个小写字母。k个条形码表示一个字符串s,每个询问表示给定的m个字符串中以s为前缀的字符串个数。

析:很容易看起来是Tire树, 不知道能不能暴过去,我觉得差不多可以,主要是在处理浮点数上,这个很简单,既然误差这么小,那么我们就可以取最大值和最小值然后除2,小的为0, 大的为1。

代码如下:

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include <cstdio>
#include <string>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <cstring>
#include <set>
#include <queue>
#include <algorithm>
#include <vector>
#include <map>
#include <cctype>
#include <cmath>
#include <stack>
#include <sstream>
#include <list>
#define debug() puts("++++");
#define gcd(a, b) __gcd(a, b)
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define freopenr freopen("in.txt", "r", stdin)
#define freopenw freopen("out.txt", "w", stdout)
using namespace std;

typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int, int> P;
const int INF = 0x3f3f3f3f;
const double inf = 0x3f3f3f3f3f3f;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int maxn = 30 * 10000 + 10;
const int mod = 10;
const int dr[] = {-1, 0, 1, 0};
const int dc[] = {0, 1, 0, -1};
const char *de[] = {"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111", "1000", "1001", "1010", "1011", "1100", "1101", "1110", "1111"};
int n, m;
const int mon[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const int monn[] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
inline bool is_in(int r, int c) {
    return r > 0 && r <= n && c > 0 && c <= m;
}

struct Trie{
  int ch[maxn][26];
  int val[maxn];
  int sz;
  void init(){
    memset(ch[0], 0, sizeof ch[0]);
    sz = 1;
  }

  int idx(char c){ return c - ‘a‘; }

  void insert(char *s){
    int u = 0;
    for(int i = 0; s[i]; ++i){
      int c = idx(s[i]);
      if(!ch[u][c]){
        memset(ch[sz], 0, sizeof ch[sz]);
        val[sz] = 0;
        ch[u][c] = sz++;
      }
      u = ch[u][c];
      ++val[u];
    }
  }

  int query(char *s){
    int u = 0;
    for(int i = 0; s[i]; ++i){
      int c = idx(s[i]);
      if(!ch[u][c])  return 0;
      u = ch[u][c];
    }
    return val[u];
  }
};

char s[50];

Trie trie;
double a[10];

int main(){
  while(scanf("%d %d", &n, &m) == 2){
    trie.init();
    for(int i = 0; i < n; ++i){
      scanf("%s", s);
      trie.insert(s);
    }
    LL ans = 0;
    while(m--){
      int k;
      scanf("%d", &k);
      for(int i = 0; i < k; ++i){
        double mmin = inf, mmax = -1;
        for(int j = 0; j < 8; ++j){
          scanf("%lf", a+j);
          mmin = min(mmin, a[j]);
          mmax = max(mmax, a[j]);
        }
        double ave = (mmin + mmax) / 2.0;
        int t = 0;
        for(int j = 0; j < 8; ++j)
          if(a[j] < ave)  t = t * 2;
          else t = t * 2 + 1;
        s[i] = t;
      }
      s[k] = 0;
      ans += trie.query(s);
    }
    printf("%I64d\n", ans);
  }
  return 0;
}

  

时间: 2024-11-03 23:03:39

HDU 3724 Encoded Barcodes (Trie)的相关文章

hdu 4825 Xor Sum(trie+贪心)

hdu 4825 Xor Sum(trie+贪心) 刚刚补了前天的CF的D题再做这题感觉轻松了许多.简直一个模子啊...跑树上异或x最大值.贪心地让某位的值与x对应位的值不同即可. 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <algorithm> 5 #include <cmath> 6 #define CLR(a,b) memset((a)

HDU 1251 统计难题 Trie题解

基本上是标准的寻找前缀的问题,只需要insert和search函数就可以了. 我这里主要是修改一下n的记录方法,这里的n代表的不是叶子节点的标志,而是有多少单词经过了这条路径的标志. 然后是查找需要查找的前缀单词,如果没有找到,就返回0,表示没有单词以这个前缀单词为前缀,如果找到,直接返回n就是答案了.因为有n个单词经过了这条路径. 查找效率是常数. 使用静态分配空间的办法. #include <stdio.h> #include <string.h> const int MAX_

UVALive 5029 Encoded Barcodes

Encoded Barcodes Time Limit:3000MS     Memory Limit:0KB     64bit IO Format:%lld & %llu Submit Status Practice UVALive 5029 Description All the big malls need a powerful system for the products retrieval. Now you are employed design a sub-system: rea

HDU 3724 字典树

Encoded Barcodes Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1644    Accepted Submission(s): 569 Problem Description All the big malls need a powerful system for the products retrieval. Now

hdu 4828 Xor Sum (trie 树模板题,经典应用)

hdu 4825 题目链接 题意:给定n个数,然后给出m个询问,每组询问一个数x,问n中的数y使得x和y的异或和最大. 思路:字典树..把每个数转化成二进制,注意补全前导0,使得所有数都有相同的位数. 如果想要异或和最大,那么每一位尽可能都是1. 所以做法是,先构建字典树,然后每次find的时候,尽可能按照和当前寻找的数的位相反的位的方向走(如果有的话) 比如当前位是1,那我就往0的方向走. 需要注意的是,多组数据,每次要重新初始化一遍. 做法是 在struct 中重新 root = new N

HDU 1671 Phone List (Trie树 好题)

Phone List Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 11721    Accepted Submission(s): 3982 Problem Description Given a list of phone numbers, determine if it is consistent in the sense th

hdu 1671 Phone List (Trie树)

简单的字典树应用,在建树的时候判断就行了. 需要注意的语法: 在使用malloc和free来处理动态内存的时候,仅仅是释放了这个对象所占的内存,而不会调用这个对象的析构函数:使用new和delete就可以既释放对象的内存的同时,调用这个对象的析构函数.所以建立trie时用new更方便一些. 注意要每组数据处理完后释放动态内存(适时释放动态内存是基本素养),否则会造成内存泄漏(提交后导致MLE).还要注意有这么个知识点: delete和free都是只把指针所指向的内存释放掉了,并没有把指针本身干掉

hdu 1251 统计难题 (Trie树)

本题是trie树模板题,如果不用trie而用map写可以看出trie处理这类问题有明显的时间优势. 在trie树中查找一个关键字的时间和树中包含的结点数无关,而取决于组成关键字的字符数.(对比:二叉查找树的查找时间和树中的结点数有关O(log2n).) 如果要查找的关键字可以分解成字符序列且不是很长,利用trie树查找速度优于二叉查找树. 若关键字长度最大是5,则利用trie树,利用5次比较可以从265=11881376个可能的关键字中检索出指定的关键字.而利用二叉查找树至少要进行log2265

HDU 1591 Encoded Love-letter(简单字符串)

Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1780    Accepted Submission(s): 635 Problem Description After Gardon had got Angel's letter, he found it was encoded...Oh my god, why did she enco